Index: trunk/include/smarty/libs/plugins/function.cycle.php
===================================================================
--- trunk/include/smarty/libs/plugins/function.cycle.php	(revision 3282)
+++ trunk/include/smarty/libs/plugins/function.cycle.php	(revision 23384)
@@ -2,6 +2,7 @@
 /**
  * Smarty plugin
+ *
  * @package Smarty
- * @subpackage plugins
+ * @subpackage PluginsFunction
  */
 
@@ -13,16 +14,15 @@
  * Date:     May 3, 2002<br>
  * Purpose:  cycle through given values<br>
- * Input:
- *         - name = name of cycle (optional)
- *         - values = comma separated list of values to cycle,
- *                    or an array of values to cycle
- *                    (this can be left out for subsequent calls)
- *         - reset = boolean - resets given var to true
- *         - print = boolean - print var or not. default is true
- *         - advance = boolean - whether or not to advance the cycle
- *         - delimiter = the value delimiter, default is ","
- *         - assign = boolean, assigns to template var instead of
- *                    printed.
- *
+ * Params:
+ * <pre>
+ * - name      - name of cycle (optional)
+ * - values    - comma separated list of values to cycle, or an array of values to cycle
+ *               (this can be left out for subsequent calls)
+ * - reset     - boolean - resets given var to true
+ * - print     - boolean - print var or not. default is true
+ * - advance   - boolean - whether or not to advance the cycle
+ * - delimiter - the value delimiter, default is ","
+ * - assign    - boolean, assigns to template var instead of printed.
+ * </pre>
  * Examples:<br>
  * <pre>
@@ -31,5 +31,6 @@
  * {cycle name=row}
  * </pre>
- * @link http://smarty.php.net/manual/en/language.function.cycle.php {cycle}
+ *
+ * @link http://www.smarty.net/manual/en/language.function.cycle.php {cycle}
  *       (Smarty online manual)
  * @author Monte Ohrt <monte at ohrt dot com>
@@ -38,20 +39,21 @@
  * @author credit to Jason Sweat <jsweat_php@yahoo.com>
  * @version  1.3
- * @param array
- * @param Smarty
+ * @param array                    $params   parameters
+ * @param Smarty_Internal_Template $template template object
  * @return string|null
  */
-function smarty_function_cycle($params, &$smarty)
+
+function smarty_function_cycle($params, $template)
 {
     static $cycle_vars;
-    
+
     $name = (empty($params['name'])) ? 'default' : $params['name'];
     $print = (isset($params['print'])) ? (bool)$params['print'] : true;
     $advance = (isset($params['advance'])) ? (bool)$params['advance'] : true;
     $reset = (isset($params['reset'])) ? (bool)$params['reset'] : false;
-            
-    if (!in_array('values', array_keys($params))) {
+
+    if (!isset($params['values'])) {
         if(!isset($cycle_vars[$name]['values'])) {
-            $smarty->trigger_error("cycle: missing 'values' parameter");
+            trigger_error("cycle: missing 'values' parameter");
             return;
         }
@@ -64,6 +66,10 @@
     }
 
-    $cycle_vars[$name]['delimiter'] = (isset($params['delimiter'])) ? $params['delimiter'] : ',';
-    
+    if (isset($params['delimiter'])) {
+        $cycle_vars[$name]['delimiter'] = $params['delimiter'];
+    } elseif (!isset($cycle_vars[$name]['delimiter'])) {
+        $cycle_vars[$name]['delimiter'] = ',';
+    }
+
     if(is_array($cycle_vars[$name]['values'])) {
         $cycle_array = $cycle_vars[$name]['values'];
@@ -71,14 +77,14 @@
         $cycle_array = explode($cycle_vars[$name]['delimiter'],$cycle_vars[$name]['values']);
     }
-    
+
     if(!isset($cycle_vars[$name]['index']) || $reset ) {
         $cycle_vars[$name]['index'] = 0;
     }
-    
+
     if (isset($params['assign'])) {
         $print = false;
-        $smarty->assign($params['assign'], $cycle_array[$cycle_vars[$name]['index']]);
+        $template->assign($params['assign'], $cycle_array[$cycle_vars[$name]['index']]);
     }
-        
+
     if($print) {
         $retval = $cycle_array[$cycle_vars[$name]['index']];
@@ -94,9 +100,7 @@
         }
     }
-    
+
     return $retval;
 }
 
-/* vim: set expandtab: */
-
 ?>
